/* 获取渲染地图数据: mapId: 地图组件id名
* data接口返回地图数据，code当前登录用户的行政区划，xzqhName行政区划名称，level: level层级
* */
function getMapEchart(mapId, data, code, xzqhName, level) {
    // 地图信息数据（各数据为0时）
    const dataMap = [
        { name: '北京', value: 0 }, { name: '天津', value: 0 },
        { name: '上海', value: 0 }, { name: '重庆', value: 0 },
        { name: '河北', value: 0 }, { name: '河南', value: 0 },
        { name: '云南', value: 0 }, { name: '辽宁', value: 0 },
        { name: '黑龙江', value: 0 }, { name: '湖南', value: 0 },
        { name: '安徽', value: 0 }, { name: '山东', value: 0 },
        { name: '新疆', value: 0 }, { name: '江苏', value: 0 },
        { name: '浙江', value: 0 }, { name: '江西', value: 0 },
        { name: '湖北', value: 0 }, { name: '广西', value: 0 },
        { name: '甘肃', value: 0 }, { name: '山西', value: 0 },
        { name: '内蒙古', value: 0 }, { name: '陕西', value: 0 },
        { name: '吉林', value: 0 }, { name: '福建', value: 0 },
        { name: '贵州', value: 0 }, { name: '广东', value: 0 },
        { name: '青海', value: 0 }, { name: '西藏', value: 0 },
        { name: '四川', value: 0 }, { name: '宁夏', value: 0 },
        { name: '海南', value: 0 }, { name: '台湾', value: 0 }, 
        { name: '南海诸岛', value: 0 }
    ];
    // 省份名称与code码键值对
    const shengNames = {
        "110000": "北京",
        "120000": "天津",
        "130000": "河北",
        "140000": "山西",
        "150000": "内蒙古",
        "210000": "辽宁",
        "220000": "吉林",
        "230000": "黑龙江",
        "310000": "上海",
        "320000": "江苏",
        "330000": "浙江",
        "340000": "安徽",
        "350000": "福建",
        "360000": "江西",
        "370000": "山东",
        "410000": "河南",
        "420000": "湖北",
        "430000": "湖南",
        "440000": "广东",
        "450000": "广西",
        "460000": "海南",
        "500000": "重庆",
        "510000": "四川",
        "520000": "贵州",
        "530000": "云南",
        "540000": "西藏",
        "610000": "陕西",
        "620000": "甘肃",
        "630000": "青海",
        "640000": "宁夏",
        "650000": "新疆"
    }
    let url = '';                         // 省份、地市、区县json文件引入路径
    let showMapBlock = true;              // 地图块是否展示标识，默认：展示
    const valueKey = 'postNum';           // 地图上显示的字段值-根据实际情况取值(eg: 今日实时量)
    // 地图图例-初始默认数值区间值-用于地图上颜色区域的划分
    let splitList = getLegendRange(100);            // 初始化avgVal：100
    let showSplitList = getShowLegendRange(0);      // 地图图例：初始化avgVal：0，unit：''
    // 中国地图: 1,2全国层级进入时
    if (level < 3) {                      
        if (data.length == 0){
            mapEchart(mapId, dataMap, '中国', splitList, 'china');
        } else {
            // 地图包含台湾及南海诸岛区域
            let realmap = [
                { name: '台湾', value: 0 }, { name: '南海诸岛', value: 0 },
            ];
            let numberlist = [];            // 数组存放所有存在的展示值
            for (const key in shengNames) {
                const item = data.find(e => e.distCode === key); // 找寻对应key值的对象值
                if (item === undefined || !item[valueKey]){ // 对应key值未找到或则该字段的展示值不存在 
                    realmap.push({ name: shengNames[key], value: '0' });
                } else {
                    realmap.push({ name: shengNames[key], value: item[valueKey] });
                    numberlist.push(Number(item[valueKey]));
                }
            };
            const maxVal = getMaxValuey(numberlist);          // 找出数组内的最大值
            const avgVal = getAvgByMax(maxVal);               // 通过最大值，处理获取图例4均分的的平均值
            let unit = '';                                    // 单位
            if(maxVal >= 10000) {
                unit = '万'; 
            }
            splitList = getLegendRange(avgVal);               // 地图图例-数值区间值
            showSplitList = getShowLegendRange(avgVal, unit);
            mapEchart(mapId, realmap, '中国', splitList, 'china');
        }
        return;
    }
    // 省、市、区的区域性地图: 3,4,5层级进入时
    if (level === 3) url = `../../json/map/${code}.js`;
    if (level === 4) url = `../../json/map/${code.substring(0, 2) + '0000'}/${code}.js`;
    if (level === 5) url = `../../json/map/${code.substring(0, 2) + '0000'}/${code.substring(0, 4) + '00'}.js`;
    if(level >= 5){           // 区县及用后层级进入时，不展示地图区域块
        showMapBlock = false;
        return;
    } 
    // 初始化数据
    let listdata = [];
    const _this = this;
    headAppendJs(url, function () {
        data = data.filter(item => item.distName != '合计'); // 过滤掉合计信息
        if (data.length === 0 || data.length === 1) {
            mapobj.features.forEach(i => {          // json文件里面的信息值
                listdata.push({
                    name: i.properties.name,
                    value: 0
                })
            });
            showMapBlock = false;                    // 无数据时，不展示地图区域
            mapEchart(mapId, listdata, xzqhName, splitList, name, mapobj);
        } else {
            let numberlist = [];
            mapobj.features.forEach(i => {
                // i.properties.adcode
                // 替换了北京110100，天津120100，上海310100，重庆500100等4个直辖市的地图json，
                // 其中新地图json中中不包含adcode字段，但其中的id与原地图中的adcode含义一致，
                // 为防止字段找不到而报错，因此转换字段
                i.properties.adcode = i.properties.adcode ? i.properties.adcode : i.properties.id;
                // const item = data.find(e => e.distCode === i.properties.adcode.toString())
                const item = data.find(e => {
                    if(level == 5 && e.countyCode == i.properties.adcode.toString()) {
                        // 区县下机构数据时,展示当前区县的数据
                        // 例如 唐山市古冶区账号查看，数据获取的是该区下的机构数据，但是显示唐山地图，数据汇总显示本区数据
                        xzqhName = e.cityName;
                        return true;
                    }
                    if(e.distCode === i.properties.adcode.toString()) {
                        return true;
                    }
                });
                if (item === undefined){
                    listdata.push({ name: i.properties.name, value: '0' });
                } else {
                    listdata.push({ name: i.properties.name, value: item[valueKey] });
                    numberlist.push(Number(item[valueKey]));
                }
            });
            const maxVal = getMaxValuey(numberlist);         // 找出数组内的最大值
            const avgVal = getAvgByMax(maxVal);              // 通过最大值，处理获取图例4均分的的平均值
            let unit = '';                                   // 单位
            if(maxVal >= 10000) {
                unit = '万'; 
            }
            splitList = getLegendRange(avgVal);              // 地图图例-数值区间值
            showSplitList = getShowLegendRange(avgVal, unit);
            mapEchart(listdata, xzqhName, splitList, xzqhName, mapobj);
        }
    });    
}
/* 获取渲染折线图数据: 单、双折线图同时支持，根据yAxisData数组长度设置，里面包含多条折线图数组数据
*  id: 绘制组件id名，xAxisData：横坐标轴数据数组，yAxisData：y坐标轴数据数组,包含多折线图时数据
* */
function getLineEchart(id, xAxisData, yAxisData) {
    let series = [];                                          // 折线图属性设置配置项数组
    let legend = ['今日', '昨日'];                             // 图例：支持多条折线
    let setColorArr = ['#1D95F4', '#1AE54B'];                 // 折线图颜色属性色系数组--绿、红
    legend.forEach((item, index) => {
        let setting = {};
        setting.data = yAxisData[index];                      // 设置y轴值
        setting.color = setColorArr[index];                   // 设置折线色值
        series.push(setting);
    });
    lineEchart(id, xAxisData, series, legend, null);
}
/* 获取渲染(含参考线)折线图数据: eg: 历史最高收寄量参考线, id: 绘制组件id名
* xAxisData：横坐标轴数据数组，yAxisData：y坐标轴数据数组,包含多折线图时数据，historyHighObj: 参考线数据信息
* */ 
function getCkLineEchart(id, xAxisData, yAxisData, historyHighObj) {
    let legend = [];
    let series = [];                       // 折线图属性设置配置项数组
    let colorArray = ['#1D95F4', '#1AE54B', '#1E1F89', '#CD01FF', '#01A572']; // 邮件类型色系数组
    legend.push(menu_right);               // 选中需要展示的邮件类型值
    legend.push('历史最高收寄量');          // 历史最高收寄量
    legend.forEach((item, idx) => {
        let symbolSet = idx == 1 ? (xAxisData.length == 1 ? 'circle' : 'none') : 'circle';
        let setting = {};
        let setColor = '';                 // 当前邮件类型设置的颜色值
        if (menu_right == '总量') {
            setColor = colorArray[0]; 
        }else if (menu_right == '特快') {
            setColor = colorArray[1];
        }else if (menu_right == '快包') {
            setColor = colorArray[2]; 
        }else if (menu_right == '普邮') {
            setColor = colorArray[3];
        }else if (menu_right == '国际') {
            setColor = colorArray[4];
        }
        if(idx == 1){                               
            setColor = '#FF0000';                   // 历史最高量色系为红色
        }
        setting.data = yAxisData[idx];
        setting.symbol = symbolSet;
        setting.color = setColor;                   // 设置折线色值
        series.push(setting);
    });
    ckLineEchart(id, xAxisData, series, legend, [35, 45], historyHighObj, [xAxisData.length, 7]);
}
/* 获取渲染柱状图数据: 单、多柱图(Y轴单刻度)同时支持，根据yAxisData数组长度设置，里面包含多条折线图数组数据
*  id: 绘制组件id名，xAxisData：横坐标轴数据数组，yAxisData：y坐标轴数据数组,包含多折线图时数据
* */
function getBarEchart(id, xAxisData, yAxisData) {
    let series = [];                                          // 柱状图属性设置配置项数组
    let legend = ['寄达量', '原寄'];                           // 图例：支持多条柱状图
    let setColorArr = ['#EF7C25', '#1D95F4'];                 // 柱状图颜色属性色系数组--蓝、绿
    legend.forEach((item, index) => {
        let setting = {};
        setting.data = yAxisData[index];                      // 设置y轴值
        setting.color = setColorArr[index];                   // 设置柱状图色值
        series.push(setting);
    });
    barEchart(id, xAxisData, series, legend, null);
}
/* 获取渲染球形图数据: id: 绘制组件id名,
* data：填充数据数组，color：填充颜色色系，isOnLine: 是否数据不存在，为‘--’
* */
function getSphereEchart(id, data, color, isOnLine = true) {
    
}




