/* 查询渲染地图数据: 支持全国、各省份、市区的区域地图查询，id: 地图组件id名, result: 接口返回数据
*  mapType地图渲染的地区,mapJson地区的json数据集, 全国时不传
* */
function queryMapEchart(id, result) {
    let data = result.list;                 // 接口返回地图数据
    let code = result.xzqh;                 // 登录用户的行政区划
    let xzqhName = result.xzqhName;         // 登录用户的行政区划名称
    let level = Number(result.level);       // 登录用户的level层级
    getMapEchart(id, data, code, xzqhName, level);
}
/* 事例--查询渲染折线图数据: 单、双折线图同时支持, result: 接口返回数据
* id: 绘制组件id名，xAxisData：横坐标轴数据数组，yAxisData：y坐标轴数据数组，包含y坐标轴其他折线数据数组
* */
function queryLineEchart(id, result) {
    let todayObj = {};              // 今日数据对象 eg:{ 0: 123, 1: 345, 2: 567 }
    let yestodayObj = {};           // 昨日数据对象
    let t = '';                     // 横坐标时间值数值
    // lineType：1，今日数据
    if (result[0].lineType === '1' && result[0].dpkPostLineDto.length > 0) {
        var today = result[0].dpkPostLineDto;
        today.forEach(e => {
            if (e.dataDateStr != '') {         
                if (dayjs().subtract(1, 'day').format("YYYY-MM-DD") == e.dataDateStr) {
                    t = 0;                                      // 昨日日期值(数组最后一项)
                } else if (dayjs().format("YYYY-MM-DD") == e.dataDateStr) {
                    t = (parseInt(e.frequency) + 1).toString(); // 今日日期值 
                }
                todayObj[t] = this.getNeedData(e, menu);        // 获取对应的值
            }
        });
    }
    // lineType：2，昨日数据
    if (result[1].lineType === '2' && result[1].dpkPostLineDto.length > 0) {
        var yestoday = result[1].dpkPostLineDto;
        yestoday.forEach(e => {
            if (e.dataDateStr != '') {
                if (dayjs().subtract(2, 'day').format("YYYY-MM-DD") == e.dataDateStr) {
                    t = 0;                                       // 前天日期值(数组最后一项)
                } else if (dayjs().subtract(1, 'day').format("YYYY-MM-DD") == e.dataDateStr) {
                    t = (parseInt(e.frequency) + 1).toString();  // 昨日日期值
                }
                yestodayObj[t] = this.getNeedData(e, menu);
            }
        });
    }
    // 0-24时间点(以整点取值)
    const dayTimes = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11',
        '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24'];
    dayTimes.forEach(e => {
        if (todayObj[e] === undefined) todayObj[e] = 0;       // 不存在值的时间节点补值0
        if (yestodayObj[e] === undefined) yestodayObj[e] = 0;
    });
    let xData = Object.keys(todayObj);                        // 返回对象中每一项key的数组
    let todayYdata = Object.values(todayObj);                 // y轴数据--今日
    let yestodayYdata = Object.values(yestodayObj);           // y轴数据--昨日
    let xAxisData = xData.map(e => {                          // x轴数据
        if (e.length === 1) return `0${e}:00`;                // 小于10的前面补0
        else return `${e}:00`;
    })
    let yAxisData = [];                                       // Y轴数据数组值
    // 空数组时默认值处理：
    xAxisData = xAxisData.length > 0 ? xAxisData : ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00',
        '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00'];
    todayYdata = todayYdata.length > 0 ? todayYdata : [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    yestodayYdata = yestodayYdata.length > 0 ? yestodayYdata : [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    yAxisData.push(todayYdata);
    yAxisData.push(yestodayYdata);
    getLineEchart(id, xAxisData, yAxisData);
}
/* 查询渲染(含参考线)折线图数据: eg: 历史最高收寄量参考线, id: 绘制组件id名, result: 接口返回数据
* xData：横坐标轴数据数组，yAxisData：y坐标轴数据数组，historyHighObj: 参考线数据信息
* */ 
function queryCkLineEchart(id, result) {
    let historyHighObj = {
        num: result[0].num,
        historyDay: result[0].historyDay,
        dateType: result.dateType,
    };
    let yAxisData = [];                                        // Y轴数据数组值
    // 空数组时默认值处理：
    let xAxisData = result.xDataArray.length > 0 ? result.xDataArray : ['09-01', '09-02', '09-03', '09-04', '09-05'];
    let totalArray = result.totalArray.length > 0 ? result.totalArray : [0, 0, 0, 0, 0]; 
    let historyHighArray = result.historyHighArray.length > 0 ? result.historyHighArray : [0, 0, 0, 0, 0]; 
    yAxisData.push(totalArray);
    yAxisData.push(historyHighArray);
    getCkLineEchart(id, xAxisData, yAxisData, historyHighObj);
}
/* 查询渲染柱状图数据: 单、多柱图同时支持，result: 接口返回数据
* id: 绘制组件id名，xAxisData：横坐标轴数据数组，yAxisData：y坐标轴数据数组，包含y坐标轴其他折线数据数组
* */
function queryBarEchart(id, result) {
    let yAxisData = [];                                        // Y轴数据数组值
    // 空数组时默认值处理：
    let xAxisData = result.xDataArray.length > 0 ? result.xDataArray : ['09-01', '09-02', '09-03', '09-04', '09-05'];
    let totalArray = result.totalArray.length > 0 ? result.totalArray : [0, 0, 0, 0, 0]; 
    yAxisData.push(totalArray);
    getBarEchart(id, xAxisData, yAxisData);
}
/* 查询渲染球形图数据: id: 绘制组件id名,
* data：填充数据数组，color：填充颜色色系，isOnLine: 是否数据不存在，为‘--’
* */
function querySphereEchart(id, result) {
    
}




