// table表格基础组件(不可下钻)
Vue.component('table-basic', {
	data() {
        return {
            // tableData: [],         // table列表数据
        }
    },
	props: {
        // id值：table组件的id值
        idName: {
            type: String,
            required: true
        },
		// table表格列头项信息
		tableColumn: {
			Array,
			default: () => {
				return []
			}
		},
		// 接口返回数据
		tableData: {
			Array,
			default: () => {
				return []
			}
		},
	},
	methods: {
        // table表格: 设置表头样式
        getHeaderClass() {
            return "background: #0197FF; color: #FFFFFF";
        },
        // table表格: 设置某一列样式
        getColClass({row, column, rowIndex, columnIndex}) {
            
        }	
	},
	mounted() {},
	// 渲染组件界面
	template: 
        `<div :id="idName" class="tableBasic">
            <el-table border
                :data="tableData"
                style="width: 100%"
                size="medium"
                :header-cell-style="getHeaderClass"
                :cell-style="getColClass"
            >
                <el-table-column
                    prop="date"
                    label="序号"
                    width="80">
                </el-table-column>
                <el-table-column
                    prop="name"
                    label="环节1"
                    width="110">
                </el-table-column>
                <el-table-column
                    prop="province"
                    label="环节2"
                    width="110">
                </el-table-column>
                <el-table-column
                    prop="city"
                    label="环节3"
                    width="110">
                </el-table-column>
            </el-table>
        </div>`
});
  