// 发运车量-路向界面组件
Vue.component('road-block', {
	data() {
		return {
			routeList: [],               // 表格列表数据(界面展示)
			routeOriList: [],            // 表格列表数据(接口返回原数组)
			routeOriLength: true,        // 表格列表长度(接口返回原数组)
			rowMoreDataFlag: false,      // 是否展示更多数据标识，默认：false: 不展开
		}
	},
	methods: {
		// 查看更多-展开功能(展示全部数据)
		lookRoadMoreOpen() {
			this.rowMoreDataFlag = true;      // 展示-更多数据内容
			this.routeList = this.routeOriList;
		},
		// 发运车量-路向查看更多-收起功能(只展示5条数据)
		lookRoadMoreFold(routeData) {
			this.routeOriLength = true;       // 折叠按钮展示标识，初始化默认展示
			this.rowMoreDataFlag = false;     // 展示-收起数据内容
			if (routeData) {
				this.routeOriList = routeData;
			}
			if (this.routeOriList.length > 0) {
				this.routeList = this.routeOriList.slice(0, 5);    // 获取数组前5条数据，并且不改变原数组
				if (this.routeOriList.length < 6) {
					this.routeOriLength = false;                   // 原数组少于6条数据时，不展示折叠按钮
				}
			}
			if (this.routeOriList.length == 0) {
				this.routeOriLength = false;                       // 原数组为空时，不展示折叠按钮
				this.routeList = [];                               // 展示数组置为空, 清空上次数据
			}
		},
		// 路向下钻功能
		lookRouteDetail(item) {
			this.$emit('lookroute', item);         // 查看详情
		},
	},
	// 渲染组件界面
	template: `<div>
		<div class="roadRowBlock">
			<div class="roadRow">
				<div class="roadRowItem roadRowHeader">
					<div class="roadRowTitle">路向</div>
				</div>
				<div class="roadRowItem roadRowHeader">
					<div class="roadRowTitle">总数</div>
				</div>
				<div class="roadRowItem roadRowHeader">
					<div class="roadRowTitle">已派车数</div>
				</div>
				<div class="roadRowItem roadRowHeader">
					<div class="roadRowTitle">未派车数</div>
				</div>
			</div>
			<div v-for="item in routeList" class="roadRow">
				<div class="roadRowItem">
					<div class="roadRowTitle">{{item.routeName}}</div>
				</div>
				<div class="roadRowItem">
					<div class="roadRowColor">{{nullToZero(item.demandnum)}}</div>
				</div>
				<div @click="lookRouteDetail(item)" class="roadRowItem">
					<div class="roadRowColor roadRowColor1">{{nullToZero(item.dispatchnum)}}</div>
				</div>
				<div class="roadRowItem">
					<div class="roadRowColor">{{nullToZero(item.notinitiatednum)}}</div>
				</div>
			</div>
			<div v-if="routeList.length == 0" class="noDataRow">
				暂无数据
			</div>
		</div>
		<div v-if="routeOriLength" class="lookRoadMoreBlock">
			<div v-if="!rowMoreDataFlag" @click="lookRoadMoreOpen()">
				查看更多<img src="../../img/icon/down_arrow.png" class="moreRoadArrow" alt="" />
			</div>
			<div v-else-if="rowMoreDataFlag" @click="lookRoadMoreFold()">
				收起<img src="../../img/icon/up_arrow.png" class="moreRoadArrow" alt="" />
			</div>
		</div>
	</div>`
});



