// 重点指标界面组件
Vue.component('zdzb-block', {
	data() {
		return {
			indicatorsObj: {},        // 重点指标对象数据信息
		}
	},
	methods: {
		// 获取重点指标对象数据信息
		getIndicatorsData(zdzbData) {
			this.indicatorsObj = zdzbData;
		},
	},
	// 渲染组件界面
	template: `<div class="blockCont">
		<div class="blockContItem">
			<div class="blockContRow contRow3">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">内部处理及时率(特快)</div>
					<div class="rowDivWord">{{indicatorsObj.nbcljslTk}}%</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">目标值</div>
					<div class="rowDivWord">{{indicatorsObj.nbcljslTkMbz}}%</div>
				</div>
			</div>
			<div class="blockContRow contRow2 contRowMarginTop">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">内部处理及时率(快包)</div>
					<div class="rowDivWord">{{indicatorsObj.nbcljslKb}}%</div>
				</div>
				<div class="blockContRowRight"> 
					<div class="rowDivTitle">目标值</div>
					<div class="rowDivWord">{{indicatorsObj.nbcljslKbMbz}}%</div>
				</div>
			</div>
			<div class="blockContRow contRow2">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">邮袋绑定率</div>
					<div class="rowDivWord">{{indicatorsObj.ydbdl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">目标值</div>
					<div class="rowDivWord">{{indicatorsObj.ydbdlMbz}}%</div>
				</div>
			</div>
			<div class="blockContRow contRow2">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">已集邮件量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.yjyjl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">环比</div>
					<div class="rowDivWord" :style="{color: getZjWordColor(indicatorsObj.yjyjlHb)}">
						{{indicatorsObj.yjyjlHb}}%
					</div>
				</div>
			</div>
			<div class="blockContRow contRow2">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">无收寄信息邮件量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.wsjxxyjl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">增减比例</div>
					<div class="rowDivWord" :style="{color: getZjWordColor(indicatorsObj.wsjxxyjlZjbl)}">
						{{indicatorsObj.wsjxxyjlZjbl}}%
					</div>
				</div>
			</div>
			<div class="blockContRow contRow2">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">异形件数量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.lylyjjbl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">增减比例</div>
					<div class="rowDivWord" :style="{color: getZjWordColor(indicatorsObj.lylyjjblZjbl)}">
						{{indicatorsObj.lylyjjblZjbl}}%
					</div>
				</div>
			</div>
			<div class="blockContRow contRow2 contRowMarginTop">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">刷单件数量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.lelyjjbl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">增减比例</div>
					<div class="rowDivWord" :style="{color: getZjWordColor(indicatorsObj.lelyjjblZjbl)}">
						{{indicatorsObj.lelyjjblZjbl}}%
					</div>
				</div>
			</div>
			<div class="blockContRow contRow2 contRowMarginTop">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">轻泡件数量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.lslyjjbl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">增减比例</div>
					<div class="rowDivWord" :style="{color: getZjWordColor(indicatorsObj.lslyjjblZjbl)}">
						{{indicatorsObj.lslyjjblZjbl}}%
					</div>
				</div>
			</div>
			<div class="blockContRow contRow2">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">邮袋丢失数(件)</div>
					<div class="rowDivWord">{{indicatorsObj.yddss}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">增减比例</div>
					<div class="rowDivWord" :style="{color: getZjWordColor(indicatorsObj.yddssZjbl)}">
						{{indicatorsObj.yddssZjbl}}%
					</div>
				</div>
			</div>
			<div class="blockContRow contRow2">
				<div class="blockContEntireRow">
					<div class="rowDivTitle">逾限总量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.yxzl}}</div>
				</div>
			</div>
			<div class="blockContRow contRow1 contRowMarginTop">
				<div class="blockContRowLeft">
					<div class="rowDivTitle">逾限特快量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.tkl}}</div>
				</div>
				<div class="blockContRowRight">
					<div class="rowDivTitle">逾限快包量(件)</div>
					<div class="rowDivWord">{{indicatorsObj.kbl}}</div>
				</div>
			</div>
		</div>
	</div>`
});
// 异常消息界面组件
Vue.component('ycxx-block', {
	data() {
		return {
			ycxxList: [],               // 列表数据(界面展示)
			ycxxOriList: [],            // 列表数据(接口返回原数组)
			ycxxOriLength: true,        // 列表长度(接口返回原数组)
		}
	},
	methods: {
		// 获取异常消息列表数据信息
		getYcxxData(ycxxData) {
			this.ycxxOriLength = true;       // 更多按钮展示标识，初始化默认展示
			if (ycxxData) {
				this.ycxxOriList = ycxxData;
			}
			if (this.ycxxOriList.length > 0) {
				this.ycxxList = this.ycxxOriList.slice(0, 5);     // 获取数组前5条数据，并且不改变原数组
				if (this.ycxxOriList.length < 6) {
					this.ycxxOriLength = false;                   // 原数组小于6条数据时，不展示更多按钮
				}
			}
			if (this.ycxxOriList.length == 0) {
				this.ycxxOriLength = false;                       // 原数组为空时，不展示更多按钮
				this.ycxxList = [];                               // 展示数组置为空, 清空上次数据
			}
		},
		// 查看更多-异常消息列表信息下钻
		lookYcMsgMore(queryType, type, itemId) {
			// 当前点击项信息参数
			let paramInfo = {
				queryType: queryType,     // 查询类型: B车辆异常
				blockType: type,          // 功能模块类型
				itemId: itemId,           // 查看消息详情的id值, 仅点击查看具体某一条消息时传,更多时不传
			};  
			try {
				Emp.execute(`$M.page.goTo('/puyuan/tjAnalyse/ycMsgListPage.html', '${JSON.stringify(paramInfo)}', false)`);
			} catch (error) {}
		},
	},
	// 渲染组件界面
	template: 
		`<div class="blockCont blockMsgCont">
			<div class="msgListBlock">
				<div v-for="(item,index) in ycxxList" class="msgBlockItem"
					@click="lookYcMsgMore('B','1',index)">
					{{item.title}}：{{item.content}}
				</div>
				<div v-if="ycxxList.length == 0" class="noDataRow">暂无数据</div>
				<div v-if="ycxxOriLength" class="msgBlockLookMore"
					@click="lookYcMsgMore('B','1')">查看更多</div>
			</div>
		</div>`
});



