// 人员异常消息列表组件
Vue.component('news-list', {
	data() {
		return {
			newsShowList: [],           // 异常消息展示的数据
			newsAllList: [],            // 异常消息全部的数据
			newsAllLength: false,    	// 异常消息长度(接口返回原数组)
		}
	},
	methods: {
		// 人员异常消息点击下钻-查看详情功能
		lookRyycDetail(index) {
			this.$emit('drilldown', 'A', '0', index);
		},
		// 查看更多功能(只展示5条数据)
		lookMoreFold(newsData) {
			if (newsData) {
				this.newsAllList = newsData;
			}
			if (this.newsAllList.length > 0) {
				this.newsShowList = this.newsAllList.slice(0, 5);    // 获取第一组，并且不改变原数组
			}
			if (this.newsAllList.length > 5) {
				this.newsAllLength = true;                           // 大于5条数据的时候，显示展示更多
			}
		},
	},
	// 渲染组件界面
	template: 
		`<div class="blockCont">
			<div class="news dot" v-for="(item,index) in newsShowList"
				@click="lookRyycDetail(index)">
				<span class="blockHeaderSpan">{{item.title}} :</span>
				<span class="newsCont">{{item.name}}</span>
				<span class="newsCont">{{item.outSourcedCompany}}</span>
				<span class="newsCont">{{item.stationArea}}</span>
			</div>
			<div v-if="newsShowList.length == 0" class="noDataRow">
				暂无数据
			</div>
			<div v-if="newsAllLength" class="lookMoreBlock" @click="lookRyycDetail()">
				查看更多
			</div>
		</div>`
});

// 车辆异常消息列表组件
Vue.component('vehicle-list', {
	data() {
		return {
			vehicleShowList: [],           // 异常消息展示的数据
			vehicleAllList: [],            // 异常消息全部的数据
			vehicleAllLength: false,    	// 异常消息长度(接口返回原数组)
		}
	},
	methods: {
		// 车辆异常消息点击下钻-查看详情功能
		lookVehicleDetail(index) {
			this.$emit('drilldown', 'B', '0', index);
		},
		// 初始展示车辆异常消息功能(只展示5条数据)
		lookMoreFold(vehicleData) {
			if (vehicleData) {
				this.vehicleAllList = vehicleData;
			}
			if (this.vehicleAllList.length > 0) {
				this.vehicleShowList = this.vehicleAllList.slice(0, 5);    // 获取第一组，并且不改变原数组
			}
			if (this.vehicleAllList.length > 5) {
				this.vehicleAllLength = true;                           // 大于5条数据的时候，显示展示更多
			}
		},
	},
	// 渲染组件界面
	template: 
		`<div class="blockCont">
			<div class="news dot" v-for="(item,index) in vehicleShowList"
				@click="lookVehicleDetail(index)">
				<span class="blockHeaderSpan newsTitle">{{item.title}} :</span>
				<span class="newsCont">{{item.content}}</span>
			</div>
			<div v-if="vehicleShowList.length == 0" class="noDataRow">
				暂无数据
			</div>
			<div v-if="vehicleAllLength" class="lookMoreBlock" @click="lookVehicleDetail()">
				查看更多
			</div>
		</div>`
});