// 界面header顶部动态插入部分省市code的json数据文件
function headAppendJs(path, callback) {
  var head = document.getElementsByTagName('head')[0];
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = path;
  head.appendChild(script);
  if (!/*@cc_on!@*/false) {
      script.onload = function () {                     // 非ie浏览器
          callback();
      }
  } else {
      script.onreadystatechange = function () {
          if (script.readystate === "loaded" || script.readState === 'complate') {   // ie浏览器
              callback();
          }
      }
  }
}
// 获取LocalStorage缓存数据, itemParam: 待获取的item
function getLocalStorageData(itemParam) {
	// localStorage.removeItem(itemParam);         // 清除缓存
	// localStorage.setItem(itemParam);            // 设置、存放缓存

	// const testFun = (data) => {
	// 	return Promise.resolve(
	// 		this.list = data
	// 	)
	// };
	// 若收寄看板结构浏览器缓存数据存在，则取缓存结构数据，不存在则取新定义的层级结构，缓存提高界面的渲染效率
	const resList = localStorage.getItem(itemParam) ? JSON.parse(localStorage.getItem(itemParam)) : [];
	// testFun(resList).then(() => { });
	return resList;
}
// 广播信息的发送, paramName: 广播名称, paramObj: 参数对象, eg: send("sj_board",{"name":"back"})
function broadcastSend(paramName, paramObj) {
	Broadcast.send(paramName,paramObj);	
}
// 广播信息的接收, paramName: 广播名称
function broadcastReceive(paramName) {
	let resData = '';
	Broadcast.receive(paramName,function(data){
		resData = data;
	});
	return resData;
}
// 获取图片base64数据, imgStr: 图片base64字符串，不带前缀, eg：iVBORw0KGgoAAAANSUhEUgAAARYAAAAMC
function getImageBase(imgStr) {
	let resImg = '', baseImg = '';
  baseImg = 'data:image/png;base64,'+imgStr;
  resImg = 'image://' + baseImg;
	return resImg;
}
// 组件传参list数据格式转化
function parseStringify(list) {
  let resData = JSON.parse(JSON.stringify(list)); 
	return resData;
}
// 最大值：获取数组中的最大值
function getMaxValue(list) {
  let resData = 0;
  if(list.length > 0){
    resData = Math.max.apply(Math, list);
  }
  return resData;
}
// 平均值：通过最大值，处理获取图例4均分的平均值
function getAvgByMax(max) {
  const pjz = parseInt(max / 4);
  const tt = Math.pow(10, Number(pjz.toString().length - 2));
  let new_value = 0;
  if (pjz % tt === 0) {
      const next = Number(pjz.toString().substring(1, 2));
      if (0 < next && next < 5) {
          new_value = (Number(pjz.toString().substring(0, 2)) + 5 - next) * tt;
      } else if (5 < next) {
          new_value = (Number(pjz.toString().substring(0, 2)) + 10 - next) * tt;
      } else {
          new_value = pjz;
      }
  } else {
      const next = pjz.toString().substring(1, 2);
      if (next < 5) {
          new_value = (Number(pjz.toString().substring(0, 2)) + 5 - next) * tt;
      } else {
          new_value = (Number(pjz.toString().substring(0, 2)) + 10 - next) * tt;
      }
  }
  return new_value;
}
// 地图图例: 数值区间值-用于地图上颜色区域的划分, 通过平均值，处理获取4均分图例
function getLegendRange(avgVal) {
  let resData = [
    { start: avgVal * 3 },
    { start: avgVal * 2, end: avgVal * 3 },
    { start: avgVal, end: avgVal * 2 }, 
    { start: 0, end: avgVal },
  ];
  return resData;
}
// 地图图例: 用于界面标度值展示, 通过平均值，处理获取4均分图例, unit: 单位
function getShowLegendRange(avgVal, unit) {
  let unitRate = 1;                                  // 换算比率，初始为单位1
  if(unit == '万') unitRate = 10000;
  unit = unit ? unit : '';                           // 单位存在，使用单位字符串，不存在，则为空字符串(单位1)
  let resData = [
    `<${(avgVal / unitRate).toFixed(1)}${unit}`,
    `<${(avgVal * 2 / unitRate).toFixed(1)}${unit}`,
    `<${(avgVal * 3 / unitRate).toFixed(1)}${unit}`,
    `<${(avgVal * 4 / unitRate).toFixed(1)}${unit}`
  ];
  return resData;
}
// 数组常用方法
// Filter: 数组的过滤--对数组的每一项都运行给定的函数，返回结果为ture的项组成的数组
function arrayFilter(sourceData) {
	let resData = sourceData.filter(item => item.name != '总计' && item.name != '合计'); // 过滤掉合计行
	return resData;
}
// Map: 返回某一属性值数组
function arrayMapAttr(sourceData) {
	let resData = sourceData.map(item => item.name);             // 返回对象中每一项name的数组
	return resData;
}
// toString: 把数组转换为数组值（逗号分隔）的字符串,
// eg: ["red", "blue", "green"] => "red,blue,green"
function arrayToString(sourceData) {
	let resData = sourceData.toString();          
	return resData;
}
// join: 将所有数组元素结合为一个字符串, 参数：separator: 分隔符，可以为 ' ',  ',',  ':'等
// eg: ["red", "blue", "green"] => "red blue green"
function arrayJoin(sourceData, separator) {
	let resData = sourceData.join(separator);          
	return resData;
}
// unshift: 在开头向数组添加新元素, 返回最新的数组, 参数：newVal: 新插入的值
// eg: ["red", "blue", "green"] =>("abc")=>  ["abc", "red", "blue", "green"] 
function arrayUnshift(sourceData, newVal) {
	let resData = sourceData.unshift(newVal);          
	return resData;
}
// pop: 从数组中删除最后一个元素, 返回 “ 被删除 ” 的值
// eg: ["red", "blue", "green"] => ["red", "blue"] 
function arrayPop(sourceData) {
	let resData = sourceData.pop();          
	return resData;
}
// splice: 删除从 index 处开始的零个或多个元素,并且用参数列表中声明的一个或多个值来替换那些被删除的元素
// 参数：(index位置, num个数, newVal添加的新元素)
// eg: [5,6,7,8] =>(1,1)=> [5,7,8], [5,6,7,8] =>(1,0,9)=> [5, 9, 6, 7, 8], [5,6,7,8] =>(1,2,3)=> [5, 3, 8] 
function arraySplice(sourceData, index, num, newVal) {
	let resData = sourceData.splice(index, num, newVal);          
	return resData;
}
// slice: 返回一个新的数组，包含从start到end（不包括该元素）的arrayObject中的元素
// 参数：(startIdx起始位置, endIdx结束位置), eg: [5,6,7,8] =>(1,3)=> [6, 7] 
// sourceData还是 [5,6,7,8]; 返回的是选定的元素，该方法不会修改原数组
function arraySlice(sourceData, startIdx, endIdx) {
	let resData = sourceData.slice(startIdx, endIdx);          
	return resData;
}
// concat: 合并数组--用于连接两个或多个数组 该方法不会改变原有的数组
// 参数：(sourceData原数组, newData新增数组), eg: [1,2,3] =>([4,5,6])=> [1, 2, 3, 4, 5, 6]
function arrayConcat(sourceData, newData) {
	let resData = sourceData.concat(sourceData, newData);          
	return resData;
}
// reverse: 反转数组--用于颠倒数组中元素的顺序,会改变原数组
// eg: [1,10,5,12,4,9,22] => [22,9,4,12,5,10,1]
function arrayReverse(sourceData) {
	let resData = sourceData.reverse();          
	return resData;
}
// Sort: 数组数据按照某一参数数据升序排列, sourceData:原数组，sortParam：升序字段
function dataUpSort(sourceData, sortParam) {
	sourceData.sort((a, b) => {
		return a[sortParam] - b[sortParam];
    // return Number(i.nameCode) - Number(n.nameCode);
	});
	return sourceData;
}
// Find: 数组的查找-用于检测数组中的元素是否满足指定条件。参数：condition：给定条件值
// 给定条件，返回数组中第一个满足该条件的值(item)，之后的值不再进行检测，当没有找到满足该条件的值时，返回undefined
function arrayFind(sourceData, condition) {
	let resData = sourceData.find(item => item.distCode == condition);          // 找寻满足条件值的对象值
	return resData;
}
// Some: 数组的检测-用于检测数组中的元素是否满足指定条件。
// 会依次执行数组的每个元素：如果有一个元素满足条件，则表达式返回true , 剩余的元素不会再执行检测, 都不满足返回false
// 不会对空数组进行检测, 不会改变原始数组
function arraySome(sourceData) {
	let resData = sourceData.some(item => { return item !== undefined });   // 返回item值不存在的项
	return resData;
}
// 对象常用方法
// Object: 获取对象中所有key值数组, eg: obj = { 0: 123, 1: 345, 2: 567 }, 返回: [0,1,2]
function objKeys(obj) {
	let resData = Object.keys(obj);              // 返回对象中每一项key的数组
	return resData;
}
// Object: 获取对象中所有value值数组, eg: obj = { 0: 123, 1: 345, 2: 567 }, 返回: [123,345,567]
function objValues(obj) {
	let resData = Object.values(obj);            // 返回对象中每一项value的数组
	return resData;
}
// 字符串常用方法
// substring: 用于提取字符串中介于两个指定下标之间的字符，包含从start到end（不包括该元素）的元素
// 参数：(startIdx起始索引值, endIdx结束索引值), eg: "Hello World!" =>(1,4)=> "ell" 
function strSubstring(sourceData, startIdx, endIdx) {
	let resData = sourceData.substring(startIdx, endIdx);          
	return resData;
}
// substr: 用于截取字符，参数num是截取的字符串的长度length, 即需要输出的字符串中的字符的个数
// 参数：(startIdx起始索引值, num提取个数), eg: "Hello World!" =>(1,4)=> "ello" 
function strSubstr(sourceData, startIdx, num) {
	let resData = sourceData.substr(startIdx, num);          
	return resData;
}
// split: 用于对一个字符串进行分割成多个字符串数组
// 参数：separator: 分隔符，可以为 ' ',  ',',  ':'等, eg: "Hello,World!" =>(,)=> ["Hello","World!"] 
// 像？.(点)（（正括弧））（反括弧）*（星号）|（竖线）等特殊符号都要在其前面加上\\
function strSplit(sourceData, separator) {
	let resData = sourceData.split(separator);          
	return resData;
}


// --------list列表上拉加载更多功能--------
// 注册并设置加载更多监听功能, wrapBlock：滚动区域块，callback：加载更多回调方法
function loadMoreListener(wrapBlock, callback) {
  const selectWrap = document.querySelector('.' + wrapBlock);
  selectWrap.addEventListener('scroll', () => {
      const scrollDistance = selectWrap.scrollHeight - selectWrap.scrollTop - selectWrap.clientHeight;
      // console.log('scrollDistance值: '+scrollDistance);
      // 同时满足以下情况，加载下一页
      // 1.页面滑动到底部，即scrollDistance = 0
      // 2.页面有滑动的情况，即selectWrap.scrollHeight > selectWrap.clientHeight
      if (scrollDistance <= 2 && selectWrap.scrollHeight > selectWrap.clientHeight) {
         callback();               // 回调方法-加载更多
      }
  })
}
// 上拉加载,展示内容滚动到最新数据位置, wrapBlock：滚动区域块，elItem：每一条滚动项
function wrapScrollTop(wrapBlock, elItem) {
  const selectWrap = document.querySelector('.' + wrapBlock);
  const el = selectWrap.querySelectorAll('.' + elItem);
  this.$nextTick(() => {
      setTimeout(()=>{
          selectWrap.scrollTop = el[el.length-1].offsetTop;  // 延时滚动，为了捕捉到操作元素
      });
  });
}
// 获取总页码数, dataTotal: 总条数, pageSize: 每页条数
function queryTotalPage(dataTotal, pageSize) {
  if(dataTotal == null) return;
  let totalPage = 0;                                     // 总页码数
  let consultPage = parseInt(dataTotal/pageSize);        // 页数商-取整           
  let remainder = dataTotal % pageSize;                  // 余数
  if(remainder == 0){
      totalPage = consultPage;                           // 总页码数
  }else{
      totalPage = consultPage+1;                         // 总页码数(有余数，页码+1)
  }
  return totalPage;
}


// tostr方法验证对象类型
const tostr = Function.prototype.call.bind(Object.prototype.toString);
// 传入判断对象: 为空返回true, 否则为false
const isblank = (a) => {
  const objstr = tostr(a);
  switch (objstr) {
    case "[object String]":
      if (a === '' || a === 'null' || a === 'undefined') {
        return true
      } else {
        return false
      }
    case ("[object Number]"):
      return false
    // Object类型判断
    case ("[object Object]"):
      if (Object.keys(a).length) {
        return false
      } else {
        return true
      }
    case "[object Null]":
      return true
    case "[object Undefined]":
      return true
    case "[object Date]":
      return false
    case "[object Array]":
      if (a.length) {
        return false
      } else {
        return true
      }
    default:
      break;
  }
}
// 加减法运算：传入加法的值即可，减法传入减数为负值
const accAdd = (arg1, arg2) => {
  var r1, r2, m;
  try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 };
  try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 };
  m = Math.pow(10, Math.max(r1, r2));
  return (arg1 * m + arg2 * m) / m;
}
// 乘法运算
const accMul = (arg1, arg2) => {
	var m = 0, s1 = 0, s2 = 0;
	isblank(arg1) ? arg1 = 0: arg1;
	m = 0, s1 = arg1.toString(), s2 = arg2.toString();
	try { m += s1.split(".")[1].length } catch (e) { };
	try { m += s2.split(".")[1].length } catch (e) { };
	return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
}
// 除法运算: 参数: arg1被除数, arg2除数
const accDiv = (arg1, arg2) => {
  var t1 = 0, t2 = 0, r1, r2;
  try { t1 = arg1.toString().split(".")[1].length } catch (e) { };
  try { t2 = arg2.toString().split(".")[1].length } catch (e) { };
  with (Math) {
    r1 = Number(arg1.toString().replace(".", ""));
    r2 = Number(arg2.toString().replace(".", ""));
    return (r1 / r2) * pow(10, t2 - t1);
  }

}
// 格式化不规则JSON, 参数为不规则JSON
const parseObject = (resp) => {
  const reg = new RegExp('"\\{', "g");
  const reg2 = new RegExp('}"', 'g');
  return JSON.parse(resp.replace(reg, '{').replace(reg2, '}'))
};
