// 获取当前时间: eg: 2022-07-08 10:30:36
function getCurTime() {
    var date = new Date();
    var year = date.getFullYear();
    var month = date.getMonth() + 1 > 9 ? date.getMonth() + 1 : "0"
            + (date.getMonth() + 1);
    var day = date.getDate() > 9 ? date.getDate() : "0" + date.getDate();
    var hour = date.getHours() > 9 ? date.getHours() : "0"
            + date.getHours();
    var minute = date.getMinutes() > 9 ? date.getMinutes() : "0"
            + date.getMinutes();
    var seconds = date.getSeconds() > 9 ? date.getSeconds() : "0"
            + date.getSeconds();
    var strDate = year + "-" + month + "-" + day + " " + hour + ":"
            + minute + ":" + seconds;
    return strDate;
}
// 获取当前日期(使用dayjs文件获取): eg: 2022-08-16
function getCurDataDate() {
    var dataDate = dayjs(new Date()).format('YYYY-MM-DD');
    return dataDate;
}
// 获取前一天（D-1）日期(使用dayjs文件获取): eg: 当前时间2022-10-17，转化为2022-10-16
function getPreDayDate() {
    var dataDate = dayjs(dayjs().subtract(1, 'day')).format('YYYY-MM-DD');  // 也可以为format('YYYY.MM.DD')格式
    return dataDate;
}
// 获取当前日期的前一个月份(T-1): eg: 当前2022-07，获取2022-06
function getPreMonth() {
    return dayjs().subtract(1, 'month').format('YYYY.MM');
}
// 中国标准时间转化为年月日: eg:'Sat Oct 10 2020 16:10:33 GMT+0800 (中国标准时间)' 转化为 2022-10-16
function bzToDateFormat(bzDate){
    let date = new Date(bzDate);
    let y = date.getFullYear();
    let m = date.getMonth() + 1;
    let d = date.getDate();
    if(m < 10){
        m = '0' + m;
    }
    if(d < 10){
        d = '0' + d;
    }
    return y + '-' + m + '-' + d;
}
// 日期格式化：eg: 毫秒, 格式化为年-月-日
function msToDateFormat(date){
    let y = date.getFullYear();
    let m = date.getMonth() + 1;
    let d = date.getDate();
    if(m < 10){
        m = '0' + m;
    }
    return y + '-' + m + '-' + d;
}
// 日期格式化: eg: 2022.07.08, 转化为2022-07-08
function dateSplitJoin(date){
    return date.split('.').join('-');
}
// 年月日格式转化: eg: 当前20220810，转化为2022-08-10
function dateJoinFormat(date){
    let year = '', month = '', day = '';
    if(date){
        year = date.substring(0, 4);
        month = date.substring(4, 6);
        day = date.substring(6, 8);
    }
    return year+'-'+month+'-'+day;
}
// 年月日格式转化: eg: 当前20210721, 转化为2021.07.21
function strToDateFormate(value, mark = '.') {
	value = value + '';                      // 转换为字符串
	if (value.length == 8) {
		const y = value.slice(0,4);
		const m = value.slice(4,6);
		const d = value.slice(6,8);
		return y + mark + m + mark + d;
	} else if (value.length == 6) {
		const y = value.slice(0,4);
		const m = value.slice(4,6);
		return y + mark + m;
	} else {
		return '';
	}
}
// 年月日格式转化: eg: 当前2021.07.21, 转化为20210721 或者 2021-07-21, 转化为20210721 
function dateToStrFormate(value, oldMark = '.', newMark = '') {
	value += ' '; 
	return value.split(oldMark).join(newMark);
}
// 截取当前日期获取月份日: eg: 当前2022-08-10，获取08-10
function dateSplitMonthDay(date){
    return date ? date.substring(5, 10) : '';
}
// 获取起止时间: eg: 2021.07.23，获取{'s': '20210723' ,'e':'20210723'}
function getStartOrEndDate(time, type="D") {
	let s = '', e = '';
	if(time){
		let chooseDate = time.split(".").join("/");
		let date = new Date(chooseDate)
		let year = date.getFullYear();
		let month = date.getMonth();
		let day = date.getDate();
		month = month + 1;
		if (month < 10) {
			month = '0' + month;
		}
		if(type == "D") {
			s = "" + year + month + "01";
			e = "" + year + month + day;
		} else if(type == 'M') {
			s = '' + year + '01';
			e = '' + year + month;
		}
	}
	return {s, e}
}

// 格式化：添加万字符
function addWan(val) {
    if (Number(val) >= 10000) {
        return (parseFloat((Number(val) / 10000).toFixed(1)) + '万');
    } else return val;
}
// 格式化：千位分隔符
function qianSeparator(num) {
    var res = num.toString().replace(/\d+/, function (n) {           // 先提取整数部分
        return n.replace(/(\d)(?=(\d{3})+$)/g, function ($1) {return $1 + ',';});
    });
    return res;
}
// 格式化：过滤字符串, 每3字符加一个逗号, 类似：千位分隔符(不能处理带小数点及正负号数据)
function addSpot(sources) {
    if(sources == '--') return '--';
    let source = sources.toString();
    if (source.length < 4) return source;
    let arr = [...source], len = arr.length / 3, newArr = [];
    for (let i = 0; i < len; i++) {
        let start = arr.length - 3 * (i + 1), b = [];
        if (start < 0) b = arr.slice(0, arr.length % 3);
        else b = arr.slice(start, arr.length - 3 * i);
        newArr.push(b.join(''));
    }
    return newArr.reverse().join(',');
}
// 格式化：大写首字母
function getUpperCase(str){
    return str.replace(/^\S/, s => s.toUpperCase());
};
// 空数据展示-
function emptyData(value, char = '-') {
    if (value && !['undefined', 'null'].includes(value)) {
        return value;
    } else {
        return char;
    }
}
// 判断是否为非空数组,返回true或者false
function isNotNullArray(arr){
    if(arr && arr.length > 0 && Array.isArray(arr)){
        return true;
    }else{
        return false;
    }
}
// 判断是否为非空数组,返回数组值或者[]
function arrayList(arr){
    if(arr && Array.isArray(arr) && arr.length > 0){
        return arr;
    }else{
        return [];
    }
}
// 判断数据是否为NaN, 如果是，则返回空 - ，否则返回Number类型的数据
function isNaNType(val){
    return val == NaN ? "-" : Number(val);
}
// 判断数据是否为undefined, null, '', 0, '0'这几种类型，这几种类型的Boolean值为false
function isTrueType(val){
    if(val == undefined || val == null || val == '' || val == 0 || val == '0'){
        return false;
    }else {
        return true;
    }
}
// 获取对象属性值，先判断对象是否为空，如果为null，则转化为0
// 非空时判定属性值property是否为undefined, null, '', 0, '0'数据,此时返回为非，若是，则转化为0
function objNumVal(obj, property){
    let resData = '0';
    if(obj){
        let val = obj[property];
        if(val){
            resData = qianSeparator(val); 
        }
    }
    return resData; 
}
// 判断是否为空undefined, null, ''数据，如果为null，则转化为0 
function nullToZero(val){
    if(val == undefined || val == null || val == ''){
        return '0';
    }else {
        return val;
    }
}
// 空占位(table列表常用)：当返回值为undefined,null,NaN,''时，此时数据展示用'-'占位
function nullBlank(val) {
    let res = val;
    if(val == undefined || val == null || val == NaN || val == ''){
        res = '-';
    }
    return res;
}
// 处理保留位数及百分比,rate：原数据，digit:保留位数
function getToFixedRate(rate,digit){
    var res = '0';
    if(rate){
        res = (parseFloat(rate)*100).toFixed(digit);
    }
    return res;
}
// 保留小数
function getFixedDecimal(value = 0, num = 1) {
    return Number(value).toFixed(num);
}
// 求和: 把数组内的值求和计算
function arrSum(arr){
    return eval(arr.join("+"));
}
// 字符串过长时，依据长度换行展示, str: 原字符串，num：截取长度
function newLineStr(str, num) {
    let resData = '', strLength = str.length;
    let len = num, twoLen = 2*num, threeLen = 3*num;
    if (strLength <= len) {
        resData = str;
    }else if (strLength > len && strLength <= twoLen) {
        resData = str.substring(0, len) + '<br>' + str.substring(len, twoLen);
    }else if (strLength > twoLen && strLength <= threeLen) {
        resData = str.substring(0, len) + '<br>' + str.substring(len, twoLen) + '<br>' + str.substring(twoLen, threeLen);
    }else if (strLength > threeLen) {
        resData = str.substring(0, len) + '<br>' + str.substring(len, twoLen) + '<br>' + str.substring(twoLen, threeLen) + '<br>' + str.substring(threeLen);
    }
    return resData;
}
// 截取字符串最后两位
function sliceLastTwoStr(str) {
    return str ? str.slice(-2) : '';
}
// 邮件类型key值转换为名称功能
function emailTypeToName(key){
    var obj = { B:'特快', K:'快包', }
    return obj[key];
}
// 设置表格项展示内容的颜色样式，itemVal: 列项信息值
function getWordColor(itemVal) {
    let resColor = '#666666';               // 黑色
    itemVal = nullToZero(itemVal);
    if (itemVal.indexOf('+') != -1) {
        resColor = '#009900';               // 绿色
    } else if (itemVal.indexOf('-') != -1) {
        resColor = '#FA2525';               // 红色
    }
    return resColor;
}
// 设置表格项展示增减比例内容的颜色样式，itemVal: 列项信息值
function getZjWordColor(itemVal) {
    let resColor = '#666666';               // 黑色
    itemVal = nullToZero(itemVal);
    if (itemVal.indexOf('+') != -1) {
        resColor = '#009900';               // 绿色
    } else if (itemVal.indexOf('-') != -1) {
        resColor = '#FA2525';               // 红色
    } else if (itemVal != '0.0' && itemVal != '0') {
        resColor = '#009900';               // 绿色
    }
    return resColor;
}
// 直辖市市辖区登录级别为市辖区的时候，显示直辖市数据  level：区域等级 xzqh: 行政区划
// areaLevel 1：全国，2：省，3：地市，4：区县
// permissionLevel 01：集团，02：全国，03：省，04：地市，05：县，06：机构
// list为字符串截取后的数组：level + '-' + xzqh + '-' + xzqhName + '-' + prov_code + '-' + city_code + '-' + conty_code + '-' + org_no
function areaLevelFormat(list, type) {
    var xzqhVal, levelVal, xzqhNameVal, result;
    if((list[1].substr(0, 2) == '11' || list[1].substr(0, 2) == '12' || 
        list[1].substr(0, 2) == '31' || list[1].substr(0, 2) == '50') && (list[0] == '4')){ 
        xzqhVal = list[1].substr(0, 2) + '0000';
        levelVal = '3';
    }else{
        xzqhVal = list[1];
        levelVal = list[0];
    }
    if(list[0] == '4') {
        switch(list[1].substr(0, 2)) {
          case '11':
            xzqhNameVal = '北京';
          break;
          case '12':
            xzqhNameVal = '天津';
          break;
          case '31':
            xzqhNameVal = '上海';
          break;
          case '50':
            xzqhNameVal = '重庆';
          break;
        }
    }
    if(type == 'xzqh'){
        result = xzqhVal;
    }else if(type == 'level'){
        result = levelVal;
    }else if(type == 'xzqhName'){
        result = xzqhNameVal;
    }
    return result;
}
// 判断是否为直辖市
function isDirectCity(code) {
    let num = code.substr(0, 2);
    let judgeCityList = ['11', '12', '31', '50'];
    if(judgeCityList.includes(num)) {
        return true;
    } else {
        return false;
    }
}
// 去掉省/市/自治区的后缀
function delNameSuffix(str){
    return str.replace(/省|市|自治区|壮族|回族|维吾尔/g, '');
}
// 行政区/机构码划特殊处理, 即：地市及以下层级进入时，行政区划设为省级
function areaCodeLimit(code){
    return code.substring(0,2) + "0000";
}
// 直辖市-市辖区: 登录级别为市辖区的时候，显示直辖市层级数据
function isDirectCityArea(level,xzqh) {
    if ((xzqh.substr(0, 2) == '11' || xzqh.substr(0, 2) == '12' || 
        xzqh.substr(0, 2) == '31' || xzqh.substr(0, 2) == '50') && (level == '4')) { 
        return true;
    }else{
        return false;
    }
}
// 获取SumLevel值(常用)--sumLevel取值: 1-全国，2-省市，3-地市，4-区县，5-机构
function getSumLevel(level) {
    let sumLevel = 1 * level <= 2 ? 1 : 1 * level - 1;      // 1,2为集团、全国
    return sumLevel;
}
// 获取sumLevel等级，存在codeLength长度参数
function getCodeLenLevel(level, codeLength) {
    if(1 * level < 3) return codeLength + '';     // 1，2全国/集团
    return 1 * level + 1 * codeLength - 2;
}
// 获取行政区划的层级名称：eg: 省份/地市/区县
function getLevelXzTitle(level) {
    if(level == 1) return '省份';
    if(level == 2) return '地市';
    if(level == 3) return '区县';
    if(level == 4 || level == 5) return '机构';
}
