// 引入QS库
function addScript(url){
    var script = document.createElement('script');
    script.setAttribute('type','text/javascript');
    script.setAttribute('src',url);
    document.getElementsByTagName('head')[0].appendChild(script);
}
addScript("https://xyd-bucket.oss-cn-beijing.aliyuncs.com/BSV/js/qs%406.7.3.js");
let base64 = new Base64();
const url = board_url;
let interface1 = axios.create({
    'Access-Control-Allow-Origin': '*',
    baseURL: url,
    timeout: 100000
});
let loadingCount = 0;
let loading;
const startLoading = () => {
    vant.Toast.loading({
        message: '加载中...',
        forbidClick: true,
        duration: 100000
    });
};
const endLoading = () => {
    vant.Toast.clear()
};
const showLoading = () => {
    if (loadingCount === 0) {
        startLoading();
    }
    loadingCount += 1;
};
const hideLoading = () => {
    if (loadingCount <= 0) {
        return;
    }
    loadingCount -= 1;
    if (loadingCount === 0) {
        endLoading();
    }
};
interface1.interceptors.request.use(
    config => {
        const params = config.params;
        if (params && !params.isHideLoading) {
            showLoading();
        }
        config.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
        // `transformRequest` 允许在向服务器发送前，修改请求数据（只能用在 'PUT', 'POST' 和 'PATCH' 这几个请求方法）
        // 此处post由json换成form表单提交方式，因为后台参数接收方式不支持json接收
		if(typeof Qs !== 'undefined' && typeof Qs.stringify == 'function'  && typeof Qs.parse == 'function') {
			config.transformRequest = [function(data) {
				  // 在请求之前对data传参进行格式转换
				  return  Qs.stringify(data)
			}]
		}
        // 后台验签使用
        // 1.获取参数，并生成msgBody字符串
        let msgBody = {}
        if (config.method === 'post' || config.method == 'POST') {
            if (config.data) {
                if (config.data.msgBody) {
                    // 删除上次请求的参数
                    delete config.data.msgBody
                }
            }
            msgBody = config.data ? config.data : {}
            msgBody = JSON.stringify(msgBody)
        } else {
            if (config.params) {
                if (config.params.msgBody) {
                    delete config.params.msgBody
                }
            }
            msgBody = config.params ? config.params : {}
            msgBody = JSON.stringify(msgBody)
        }
        // 2.按规则生成签名
        const sendID = '00000001';
        const key = '83d7b121e335';
        const timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss');
        const dataDigest = base64.encode(hex_md5(msgBody + key + timestamp));
        // 3.将验签内容，已参数形式传向后台, 插入验签内容(get形式)
        if (config.method == 'post' || config.method == 'POST') {
            config.data = {};
            config.data['sendID'] = sendID;
            config.data['timestamp'] = timestamp;
            config.data['msgBody'] = msgBody;
            config.data['dataDigest'] = dataDigest;
        } else {
            config.params = {};
            config.params['sendID'] = sendID;
            config.params['timestamp'] = timestamp;
            config.params['msgBody'] = msgBody;
            config.params['dataDigest'] = dataDigest;
        }
        return config;
    },
    error => {
        return Promise.reject(error).catch((e) => {})
    }
);
interface1.interceptors.response.use(
    data => {
        hideLoading();
        return data.data;
    },
    error => {
        hideLoading();
        return Promise.reject(error);
    }
);











