// 入参base64格式转换方法引入
let base64 = new Base64();
window.mockData = true;             // 是否启用本地开发mock数据: 默认: false 不启用
// 接口请求处理： url: 请求接口地址，method：请求方法：默认为get方式请求，params：请求参数
// isShowLoad: 是否需要遮罩加载层, 默认为yes需要，如果不需要，则入参param对象里面添加：isShowLoad: 'no'即可
// isLevelPermiss: 是否需要getLevelFromPermission, 默认为yes需要，如果不需要，则入参param对象里面添加：isLevelPermiss: 'no'即可
const requestMethod = (param) => {
    return interface({
        url: param.url,
        method: param.method ? param.method : 'get',  
        params: param.data,
        isShowLoad: param.isShowLoad ? param.isShowLoad : 'yes', 
        isLevelPermiss: param.isLevelPermiss ? param.isLevelPermiss : 'yes', 
    });
};
let interface = axios.create({
    'Access-Control-Allow-Origin': '*',      // 允许跨域请求
    baseURL: board_url,                      // 请求域名地址                                                           
    timeout: 10000                           // 请求超时时长
});
let loadingCount = 0, loading;
// 打开接口请求Toast加载层
const showLoading = () => {
    if (loadingCount === 0) {
        startLoading();
    }
    loadingCount += 1;
};
// 关闭接口请求Toast加载层
const hideLoading = () => {
    if (loadingCount <= 0) {
        return;
    }
    loadingCount -= 1;
    if (loadingCount === 0) {
        endLoading();
    }
};
const startLoading = () => {
    vant.Toast.loading({
        message: '加载中...',
        forbidClick: true,
        duration: 10000
    });
};
const endLoading = () => {
    vant.Toast.clear();
};
// 入参增加权限转换，默认需要
let isPermissionControl = true;
// 权限等级参数设置，普元页面注入的方法
let permissionLevel = '01';
let permissionCode = '100000';
function getAccountPermission(level,code){
	if(code == '000000'){
		code = '100000';
	}
	permissionLevel = level;
	permissionCode = code;
}
function getAccountLevel(){
	return permissionLevel;
}
function getAccountCode(){
	return permissionCode;
}
/**
 * 根据下钻层级，返回最终传给后台的区域等级
 * areaLevel 1：全国，2：省，3：地市，4：区县
 * permissionLevel 01：集团，02：全国，03：省，04：地市，05：县，06：机构
 * @param level 下钻层级
 */
function getLevelFromPermission(level){
	if(permissionLevel == '01' || permissionLevel == '02'){
		return level;
	}else if(permissionLevel == '03'){
		return level + 1;
	}else if(permissionLevel == '04'){
		return level + 2;
	}else{
		return level + 3;
	}
}
/**
 * 根据下钻层级返回区域等级名称
 */
function getNameFromPermission(level,ignore3 = true){
	let lv = getLevelFromPermission(level);
	if(lv == 3 && ignore3){
		lv = 4;            // 部分页面地市直接下钻到机构，这里默认忽略了区县级
	}
	if(lv == 1){
		return '省份';
	}else if(lv == 2){
		return '地市';
	}else if(lv == 3){
		return '区县';
	}else{
		return '机构';
	}
}
// 接口请求: request处理
interface.interceptors.request.use( 
    config => {
        config.isShowLoad == 'yes' ? showLoading() : null;     // interface4去掉遮罩加载层，只需要请求时弹层去掉不弹出即可          
        // ['Content-Type'] = 'application/json': json格式提交，
        // 'application/x-www-form-urlencoded': form表单提交方式
        config.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
        // 只有本地模拟数据，不用后台验签
        // 后台验签使用: 几乎每个接口都使用
        // 1.获取参数，并生成msgBody字符串，项目中get方式比较多
        let msgBody = {};
        if (config.method === 'post' || config.method == 'POST') {
            if (config.data) {
                if (config.data.msgBody) {
                    delete config.data.msgBody           // 删除上次请求的参数
                }
            }
            msgBody = config.data ? config.data : {};
            msgBody = JSON.stringify(msgBody);
        } else {
            if (config.params) {
                if (config.params.msgBody) {
                    // 删除上次请求的参数
                    delete config.params.msgBody
                }
            }
            msgBody = config.params ? config.params : {};
            // 接口附加权限控制的level和code字段，如果涉及下钻，根据权限转换下钻层级
            if(permissionLevel){
                msgBody.level = permissionLevel;
                msgBody.code = permissionCode;
                if(msgBody.areaLevel){
                    if(config.isLevelPermiss == 'yes'){
                        msgBody.areaLevel = getLevelFromPermission(Number(msgBody.areaLevel));
                    }                                          // interface3: 不需要
                    if(!msgBody.areaCode){
                        msgBody.areaCode = permissionCode;
                    }
                }
            }
            msgBody = JSON.stringify(msgBody);
        }
        // 2.按规则生成签名
        const sendID = '00000001';
        const key = '83d7b121e335';
        const timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss');              // 时间戳
        const dataDigest = base64.encode(hex_md5(msgBody + key + timestamp)); // 数字签名
        // 3.将验签内容，以参数形式传向后台
        // 插入验签内容(get形式比较多)
        if (config.method == 'post' || config.method == 'POST') {
            config.data = {};
            config.data['sendID'] = sendID;
            config.data['timestamp'] = timestamp;
            config.data['msgBody'] = msgBody;
            config.data['dataDigest'] = dataDigest;
        } else {
            config.params = {};
            config.params['sendID'] = sendID;
            config.params['timestamp'] = timestamp;
            config.params['msgBody'] = msgBody;
            config.params['dataDigest'] = dataDigest;
        }
        return config;
    },
    error => {
        return Promise.reject(error).catch((e) => {})
    },
    defaults => { }
);
// 接口响应: response处理
interface.interceptors.response.use(
    data => {
        hideLoading(); 
        if(data.data.flag && data.data.data !== 'null' && data.data.data !== '[]'){
        	return data.data;
        }else{
            return "";
        }                     
    },
    error => {
        hideLoading();
        return Promise.reject(error);
    }
);